/*
 *  JEITA DCF [`
 *	Ref. JEITA CP-3461A.
 */
#include "viewer.h"
#include "ff.h"
#include "monitor.h"
#include "grphcon.h"
#include "event.h"
#include "exif.h"
#include "LCDpanel.h"
#include "dcf.h"
#include "tinylib.h"
#include "TouchPanel.h"
#include "cpu.h"

/*
 *  nthԖڈȍ~̃t@C
 */
int seek_DCF(int nth)
{
    int nfiles, fnumber;
    int index, num_read;
    FRESULT res;
    BYTE i;
    char *fn;
    char dirpath[16];
    DIR dirs, dcfdir;
    FILINFO dir_finfo, dcfdir_finfo;
    struct dcf_file_info *pdcf;
    FIL  jpegfile;

    if (nth >= dcf_info.num_files)
	return 0;
    if (nth == dcf_info.findex) {
	return dcf_info.nfiles;
    }
    xprintf("seek: %d, %d\n", nth, dcf_info.findex);

    if (nth > dcf_info.findex && nth < dcf_info.findex + DCF_BUF_SIZE) {
	/* At least one file information is already there. */
	index = nth - dcf_info.findex;
	nfiles = dcf_info.nfiles - index;
	memcpy(&dcf_files[0], &dcf_files[index], sizeof(struct dcf_file_info)*nfiles);
	xmemset(&dcf_files[nfiles], 0, sizeof(struct dcf_file_info)*(DCF_BUF_SIZE-nfiles));
	dcf_info.findex = nth;
	dcf_info.nfiles = nfiles;
	/* Determin index to read */
	index = nfiles;
	nth = nth + nfiles;
	nfiles = DCF_BUF_SIZE - nfiles;
    } else {
	index = 0;
	nfiles = DCF_BUF_SIZE;
	dcf_info.findex = nth;
	dcf_info.nfiles = 0;
    }
    if (nth + nfiles > dcf_info.num_files)
        nfiles = dcf_info.num_files - nth;
#ifdef DEBUG
	xprintf("read: %d, %d, %d\n", nth, nfiles, index);
#endif
    /*
     *  nthԖڈȍ~Anfiles̃t@CɊւW߂āA
     *  obt@ indexŎʒuɊi[B
     */
    fnumber = num_read = 0;
    dcf_info.nfiles += nfiles;
    pdcf = dcf_files + index;

    strcpy(dirpath, "/DCIM/");
    res = f_opendir(&dirs, "/DCIM");	/* fBNgJ */
    if (res != FR_OK)
        return 0;

    while (((res = f_readdir(&dirs, &dir_finfo)) == FR_OK) && dir_finfo.fname[0]) {
	fn = dir_finfo.fname;	/* LFN\ł͏SFN */
	if (!(dir_finfo.fattrib & AM_DIR)) continue;	/* Skip non directory file */
        /*
         * DCFfBNg̍ŏ3 "000"`"999"łȂ΂ȂȂ
         */
        if (strncmp(fn, "100", 3) < 0 || strncmp(fn, "999", 3) > 0) continue;
        i = xstrlen(fn);
	if (i != 8) continue;
	strcpy(dirpath + 6, fn);
	dirpath[6 + i] = '\0';

	res = f_opendir(&dcfdir, dirpath);
        while (((res = f_readdir(&dcfdir, &dcfdir_finfo)) == FR_OK) && dcfdir_finfo.fname[0]) {
	    fn = dcfdir_finfo.fname;	/* LFN\ł͏SFN */
	    if (dcfdir_finfo.fattrib & AM_DIR) continue;
	    if (xstrlen(fn) != 12) continue;
	    if (strncmp(fn + 9, "JPG", 3)) continue;
            if (fn[0] == '_') continue;	/* IvVt@C𖳎 */
	    if (strncmp(fn + 4, "0001", 4) <= 0 || strncmp(fn + 4, "9999", 4) > 0) continue;
            if (fnumber >= nth && fnumber < nth + nfiles) {
		pdcf->flag = 1;
		strcpy(pdcf->pathname, dirpath);
		strcpy(pdcf->pathname + 14, "/");
		strcpy(pdcf->pathname + 15, fn);
		pdcf->fsize = dcfdir_finfo.fsize;
		res = f_open(&jpegfile, pdcf->pathname, FA_READ);
		if (res == FR_OK) {
		    CollectExif(&jpegfile, &pdcf->exif_info);
		    f_close(&jpegfile);
		}
		pdcf++;
	        num_read++;
	    }
	    fnumber++;
	    if (num_read == nfiles)
	        break;
	}
    }
    return nfiles;
}

/*
 * SDJ[h DCFfBNg̐ƁA̒DCFt@C̐߂B
 * (݂́AfBNg͎ۂɂ͎gpĂȂ)
 */
FRESULT scan_DCF ()
{
    FRESULT res;
    BYTE i;
    char *fn;
    char dirpath[16];
    DIR dirs, dcfdir;
    FILINFO dir_finfo, dcfdir_finfo;
    struct dcf_file_info *pdcf;
    FIL  jpegfile;

    strcpy(dirpath, "/DCIM/");
    res = f_opendir(&dirs, "/DCIM");	/* fBNgJ */

    if (res != FR_OK)
        return res;

    dcf_info.findex = -1;
    dcf_info.nfiles = 0;
    dcf_info.num_dirs = dcf_info.num_files = 0;

    xmemset(&dcf_files[0], 0, sizeof(struct dcf_file_info)*DCF_BUF_SIZE);

    pdcf = dcf_files;
    while (((res = f_readdir(&dirs, &dir_finfo)) == FR_OK) && dir_finfo.fname[0]) {
	fn = dir_finfo.fname;	/* LFN\ł͏SFN */
	if (!(dir_finfo.fattrib & AM_DIR)) continue;	/* Skip non directory file */
        /*
         * DCFfBNg̍ŏ3 "000"`"999"łȂ΂ȂȂ
         */
        if (strncmp(fn, "100", 3) < 0 || strncmp(fn, "999", 3) > 0) continue;
        i = xstrlen(fn);
	if (i != 8) continue;
        dcf_info.num_dirs++;
	strcpy(dirpath + 6, fn);
	dirpath[6 + i] = '\0';

	res = f_opendir(&dcfdir, dirpath);

        while (((res = f_readdir(&dcfdir, &dcfdir_finfo)) == FR_OK) && dcfdir_finfo.fname[0]) {
	    fn = dcfdir_finfo.fname;	/* LFN\ł͏SFN */
	    if (dcfdir_finfo.fattrib & AM_DIR) continue;
	    if (xstrlen(fn) != 12) continue;
	    if (strncmp(fn + 9, "JPG", 3)) continue;
            if (fn[0] == '_') continue;	/* IvVt@C𖳎 */
	    if (strncmp(fn + 4, "0001", 4) <= 0 || strncmp(fn + 4, "9999", 4) > 0) continue;
	    if (dcf_info.findex < 0) dcf_info.findex = 0;
	    if (dcf_info.nfiles < DCF_BUF_SIZE) {
		pdcf->flag = 1;
		strcpy(pdcf->pathname, dirpath);
		strcpy(pdcf->pathname + 14, "/");
		strcpy(pdcf->pathname + 15, fn);
		pdcf->fsize = dcfdir_finfo.fsize;
#ifdef XDEBUG
xprintf("%x: %s\n", pdcf, pdcf->pathname);
#endif
		res = f_open(&jpegfile, pdcf->pathname, FA_READ);
		if (res == FR_OK) {
		    CollectExif(&jpegfile, &pdcf->exif_info);
		    f_close(&jpegfile);
		}
		pdcf++;
		dcf_info.nfiles++;
	    }
	    dcf_info.num_files++;
	}
    }
#ifdef XDEBUG
xprintf("nfiles = %d\n", dcf_info.nfiles);
#endif

    return res;
}

#define	N_PROGRAM 9

char *exp_programs[N_PROGRAM] = {
  "Undef",
  "ƭ",
  "۸",
  "iD",
  "D",
  "creative",
  "action",
  "l",
  "i",
};

#define	N_LIGHT	24
char *light_sources[N_LIGHT] = {
  "s", "", "u", "d", "tbV",	/* 0 .. 4 */
  "̑", "̑", "̑", "̑",		/* 5 .. 8 */
  "V", "ܓV", "A", "Fu",		/* 9 .. 12 */
  "Fu", "Fu", "Fu",		/* 13, 14, 15 */
  "̑",						/* 16 */
  "WA", "WB", "WC",			/* 17, 18, 19 */
  "D55", "D65", "D75", "D50",				/* 20 .. 23 */
};

#define	N_METERING	7
char *metering_modes[N_METERING] = {
  "s",
  "",
  "d_",
  "X|bg",
  "߯",
  "",
  "",
};

char *flash_modes[] = {
  "s",
  "",
  "֎~",
  "",
};

char *flash_results[] = {
  "",
  "L"
};

char *exp_modes[] = {
  "",
  "}jA",
  "ׯ",
  "\\",
};

char *wb_modes[] = {
  "",
  "}jA",
};

/*
 * Exif\
 */
void show_exif(char *pathname, EXIF *exif)
{
    char *str;
    int mode;
    int divisor, val;

    GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
    GRPH_Clear(C_BLACK);
    GCON_clear();
    if (exif->no_app1) {
	GCON_locate (5, 10);
	t_printf("̃t@CExif`ł͂܂");
	ev_get(1);
	return;
    }
    /*
     * TlC摜̐L/\
     */
    expand_thumbnail(pathname, exif->thumb_offset, -1);

    /* ISOx\ */
    GCON_set_color(C_BLACK|ALPHA15, C_WHITE|ALPHA15);
    GCON_locate(21, 0); t_printf("ISO");
    GCON_set_color(C_WHITE|ALPHA15, C_BLACK);
    t_printf(" %d", exif->iso_speed);
    /* Fio\ */
    GCON_locate(21, 1);
    if (exif->f_number[1] == 10) {
	t_printf("F%d.%d", exif->f_number[0]/10, exif->f_number[1] % 10);
    } else {
	t_printf("F%d/%d", exif->f_number[0], exif->f_number[1]);
    }
    /* Iԕ\ */
    t_printf("  %d/%db", exif->exp_time[0], exif->exp_time[1]);

    /* œ_\ */
    divisor = exif->focal_length[1];
    val = exif->focal_length[0]%divisor;
    while (val > 10 && ((val % 10) == 0))
	val /= 10;
    GCON_locate(21, 2);
    t_printf("œ_: %d.%dmm", exif->focal_length[0]/divisor, val);

    if (exif->exp_program) {	/* Be[h */
        if (exif->exp_program < N_PROGRAM)
	    str = exp_programs[exif->exp_program];
        else
	    str = "̑";
        GCON_locate(21, 3);
        t_printf("BeӰ: %s", str);
    }
    if (exif->metering) {	/*  */
        if (exif->metering < N_METERING)
	    str = metering_modes[exif->metering];
        else
	    str = "̑";
        GCON_locate(21, 4);
        t_printf(": %s", str);
    }
    if (exif->light_source) {	/*  */
        if (exif->light_source < N_LIGHT)
	    str = light_sources[exif->light_source];
        else
	    str = "̑";
        GCON_locate(21, 5);
        t_printf(": %s", str);
    }

    /* Io */
    GCON_locate(21, 6);
    t_printf("Io: %s", exp_modes[exif->exp_mode & 3]);

    /* zCgoX */
    GCON_locate(21, 7);
    t_printf("WB: %s", wb_modes[exif->wb_mode & 1]);

    GCON_locate(0, 8);
    t_printf("f: %d X %d (%d)\n",
		exif->image_width, exif->image_height, exif->orientation);
    t_printf("𑜓x: %d/%d%s", exif->resolution[1], exif->resolution[0],
	(exif->resolution_unit == 1)? "cm" : "inch");

    mode = (exif->flash >> 3) & 3;
    str = flash_modes[mode];
    GCON_locate(0, 10);
    t_printf("tbV: %s", str);
    if (mode == 3) {
	t_printf(" (%s)", flash_results[exif->flash&1]);
    }

    GCON_locate(0, 11);
    t_printf("[J: %s\n", exif->maker);
    t_printf("f: %s\n", exif->model);
    t_printf("Be: %s", exif->date_time);
    ev_get(1);
}

evinfo saved_event;

void ev_save(evinfo *evp)
{
    saved_event = *evp;
}

void ev_clear()
{
    saved_event.ev_time = 0;
}

int find_touch_event(evinfo *evp)
{
    int xdiff, ydiff;
    int xabs, yabs;
    int xpos, ypos;
    int event;

    if (evp->ev_time - saved_event.ev_time > 1000)
	return EV_NOP;
    xpos = TOUCH_XVAL(evp->tp_val);
    ypos = TOUCH_YVAL(evp->tp_val);
    xabs = xdiff = xpos - TOUCH_XVAL(saved_event.tp_val);
    yabs = ydiff = ypos - TOUCH_YVAL(saved_event.tp_val);
    if (xdiff < 0) xabs = -xdiff;
    if (ydiff < 0) yabs = -ydiff;
    if (xabs > 80 || yabs > 60) {	/* XN[wƔ肷 */
	/* ړʂ̑𔻒ɗp */
	if (yabs > xabs) {
	    event = (ydiff < 0)? EV_SCROLL_DOWN : EV_SCROLL_UP;
	} else {
	    event = (xdiff < 0)? EV_SCROLL_DOWN : EV_SCROLL_UP;
	}
	return event;
    }
    return EV_NOP;
}

void dcf_viewer()
{
    FRESULT res;
    int need_read, need_draw, need_collect, nfiles;
    int gotev, cpos, ppos;
    int xpos, ypos, picpos;
    int dlen, event;
    struct dcf_file_info *pdcf;
    EXIF *exif;
    int thumb_top;	/* ŏɕ\Ă摜̔ԍ */
    evinfo *evp;
    UINT sel_time;
    char temp_buffer[40];

    GRPH_SelectPlane((PIXEL *)GRA2_VRAM_BASE); /* eLXgv[I */

    /* J[h DCFfBNg̐ƁA̒DCFt@C̐߂B*/
    res = scan_DCF ();

    if (res != FR_OK)
	return;
    xprintf("dirs: %d, files: %d\n", dcf_info.num_dirs, dcf_info.num_files);

    if (dcf_info.num_files == 0) {	/* No file??? */
	/* XXX  Need to show error message */
	return;
    }
    thumb_top = 0;
    need_read = 1;
    need_draw = 0;
    nfiles = cpos = 0;

    do {
	if (need_read) {
	    nfiles = seek_DCF(thumb_top);
	    need_read = 0;
	    need_draw = 1;
	    need_collect = 1;
	}
	if (need_draw) { /* TlC摜\Kv */
	    /* OtBbNXv[I */
            GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
	    GRPH_Clear(C_BLACK);		/* OtBNẌNA */
	    GCON_clear();

            /* TlC摜 nfiles\ */
	    pdcf = &dcf_files[0];
	    for (picpos = 0; picpos < nfiles; picpos++) {
		expand_thumbnail(pdcf->pathname, pdcf->exif_info.thumb_offset, picpos);
		pdcf++;
	    }
	    need_collect = need_draw = 0;

	    /* eLXgv[I */
            GRPH_SelectPlane((PIXEL *)GRA2_VRAM_BASE);
	}

	/* cpos ̈ʒuɉ摜IJ[\\(eLXgv[) */
        xpos = 80 * (cpos % 4);
	ypos = 60 * (cpos / 4);
	GRPH_Box(xpos,   ypos,   xpos + 80 - 1, ypos + 60 - 1, C_WHITE|ALPHA15, 0);
	GRPH_Box(xpos+1, ypos+1, xpos + 80 - 2, ypos + 60 - 2, C_WHITE|ALPHA15, 0);
	GRPH_Box(xpos+2, ypos+2, xpos + 80 - 3, ypos + 60 - 3, C_BLACK|ALPHA15, 0);
	GRPH_Box(xpos+3, ypos+3, xpos + 80 - 4, ypos + 60 - 4, C_BLACK|ALPHA15, 0);
        sel_time = get_time_tick();

	pdcf = &dcf_files[cpos];
	exif = &pdcf->exif_info;

	/* IĂ摜Ɋւ\ */
	xprintf("%d: %s (%d)\n", dcf_info.findex + cpos, pdcf->pathname, pdcf->fsize);
	GCON_locate(0, 12);
	t_printf("t@C: %s\n", pdcf->pathname);
	GCON_clear_line(13);
	GCON_clear_line(14);
	if (exif->no_app1 == 0) {
	    t_printf("Be: %s\n", exif->date_time);
	    t_printf("f: %d X %d (%d)",
		exif->image_width, exif->image_height, exif->orientation);
	}
	t_sprintf(temp_buffer, "%d/%d",
		dcf_info.findex + cpos + 1, dcf_info.num_files);
	dlen = t_strlen(temp_buffer);
	GCON_locate(40 - dlen - 1, 14);
	t_puts(temp_buffer);

	ppos = cpos;

        /* ͂ꂽCxgɑΉANVs */
	do {
	    gotev = 1;

	    evp = ev_get(1);
	    event = evp->ev_type;

	    if (event == EV_PENDOWN) {
		{
		    int xpos, ypos, tpos;
		    UINT tdiff;

		    xpos = TOUCH_XVAL(evp->tp_val);
		    ypos = TOUCH_YVAL(evp->tp_val);
		    ev_save(evp);
		    if (ypos < 180) {
			tpos = ypos / 60 * 4 + xpos / 80;
			if (tpos == cpos) {
			    /*
			     * łɑIς݂̉摜^b`ꂽ
			     * IĂ̌oߎԂŃANV肷
			     */
			    tdiff = get_time_tick() - sel_time;
			    if (tdiff > 850)	/* 850msȏo߂͖ */
				event = EV_NOP;
			    else if (tdiff < 350)	/* 350msȉŃXChV[ */
				event = EV_SEL_LEFT;
			    else
			        event = EV_SEL_RIGHT;	/* ȊO 摜\ */
			} else {
			    if (dcf_info.findex + tpos < dcf_info.num_files) {
			        cpos = tpos;	/* I摜ύX */
			    }
			    event = EV_NOP;
			}
		    } else {
			gotev = 0;
		    }
		}
	    } else if (event == EV_PENUP) {
		event = find_touch_event(evp);
	    }

	    switch (event) {
	    case EV_SCROLL_UP:	/* Õy[W̍Ō̉摜ֈړ */
		if (dcf_info.findex > 0)
		    cpos = -1;
		break;
	    case EV_SCROLL_DOWN: /* ̃y[W̍ŏ̉摜ֈړ */
		if (dcf_info.findex + 12 < dcf_info.num_files)
		    cpos = 12;
		break;
	    case EV_UP_KEY:	/* O̍sɈړ */
	        if (dcf_info.findex + cpos >= 4) cpos -= 4;
	        break;
	    case EV_DOWN_KEY:	/* ̍sɈړ */
	        if (dcf_info.findex + cpos + 4 < dcf_info.num_files) cpos += 4;
	        break;
	    case EV_LEFT_KEY:	/* ÖʒuɈړ */
	        if (cpos == 0 && dcf_info.findex == 0)
		    break;
	        cpos--;
	        break;
	    case EV_RIGHT_KEY:	/* ̈ʒuɈړ */
	        if (dcf_info.findex + cpos + 1 == dcf_info.num_files)
		    break;
	        cpos++;
	        break;
	    case EV_SEL_RIGHT:	/* SEL_RIGHT Sʂɉ摜\ */
                GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
	        GRPH_Clear(C_BLACK);
		GCON_clear();
		if (expand_jpeg(pdcf->pathname, exif->orientation) == 0) {
		    GCON_locate(5, 7);
		    t_puts("摜傫ĕ\\ł܂");
		    delay_ms(300);
		}
		ev_flush();
		ev_clear();
		evp = ev_get(1);
		if (evp->ev_type == EV_PENDOWN || evp->ev_type == EV_SEL_RIGHT) {
		    show_exif(pdcf->pathname, exif);
		    if (evp->ev_type == EV_PENDOWN) {
			ev_wait(EV_PENUP);
		    }
		}
		need_draw = 1;
		break;
	    case EV_SEL_LEFT:	/* SEL_LEFT XChV[Jn */
		cpos = slide_show(cpos);
		thumb_top = dcf_info.findex;
		need_read = 1;
		need_draw = 1;
		break;
	    case EV_NOP:
		break;
	    default:
		gotev = 0;
	        break;
	    }
	} while (gotev == 0);

	if (event == EV_SEL_RIGHT || event == EV_SEL_LEFT) {
	    /* TlC摜\Kv */
	    continue;
	}

        /* 摜IJ[\ */
        xpos = 80 * (ppos % 4);
	ypos = 60 * (ppos / 4);
	GRPH_Box(xpos,   ypos,   xpos + 80 - 1, ypos + 60 - 1, C_BLACK|ALPHA0, 0);
	GRPH_Box(xpos+1, ypos+1, xpos + 80 - 2, ypos + 60 - 2, C_BLACK|ALPHA0, 0);
	GRPH_Box(xpos+2, ypos+2, xpos + 80 - 3, ypos + 60 - 3, C_BLACK|ALPHA0, 0);
	GRPH_Box(xpos+3, ypos+3, xpos + 80 - 4, ypos + 60 - 4, C_BLACK|ALPHA0, 0);

	if (cpos < 0) {
	    thumb_top -= 12;
	    cpos += 12;
	    need_read = 1;
	}
	if (cpos >= 12) {
	    thumb_top += 12;
	    cpos -= 12;
	    need_read = 1;
	}
    } while (1);
}
