#include "tinylib.h"
#include "monitor.h"

void delay_us(int us)
{
    while (us > 0)
	us--;
}

void *memset(void *s, int c, int count)
{
    return xmemset(s, c, count);
}

int memcmp(const void *s1, const void *s2, int count)
{
    return t_memcmp((char *)s1, (char *)s2, count);
}

void *memcpy(void *to, const void *from, int count)
{
    const char *cfrom = from;
    char *cto = to;

    while (count-- > 0) {
	*cto++ = *cfrom++;
    }
    return (void *)to;
}

char *strcpy(char *dest, const char *src)
{
    char *p = dest;

    while (*src) {
	*dest++ = *src++;
    }
    *dest = 0;
    return p;
}

char *strncpy(char *dest, const char *src, int cnt)
{
    char *p = dest;

    while (cnt > 0) {
        if (!*src) {
	    *dest = 0;
	    return p;
	}
	*dest++ = *src++;
	cnt--;
    }
    return p;
}

int strncmp(char *s, char *d, int cnt)
{
  while(*s == *d) {
    if (cnt == 0) return 0;
    if(!*s) return 0;
    s++;
    d++;
    cnt--;
  }
  return *s - *d;
}
